var whenLastTabSwitch = new Date (), urlLastRiverGet;

//electron shell stuff -- 3/23/17 by DW
	function shellOpenUrl (url) {
		require ("electron").ipcRenderer.send ("asynch-message", "openUrl", url);  
		}
	function shellOpenFolder (folder) {
		require ("electron").ipcRenderer.send ("asynch-message", "openFolder", folder);  
		}
//websockets -- 2/1/16 by DW
	var mySocket = undefined;
	
	function webSocketClient (s) {
		var splitUrl = urlSplitter (window.location.href), host;
		var urlSocket = "ws://" + splitUrl.host + ":" + serverConfig.webSocketPort + "/";
		console.log ("webSocketClient: urlSocket == " + urlSocket);
		
		mySocket = new WebSocket (urlSocket); 
		mySocket.onopen = function (evt) {
			console.log ("mySocket is open.");
			console.log ("sending: " + s);
			mySocket.send (s);
			};
		mySocket.onmessage = function (evt) {
			var eventData = evt.data.toString ();
			var words = eventData.split (" ");
			if (words.length >= 2) { //new protocol as of 11/29/15 by DW
				switch (words [0]) {
					case "updated":
						var listname = stringPopExtension (stringLower (trimWhitespace (words [1]))) + ".js";;
						console.log ("webSocketClient, list updated: listname == " + listname);
						for (var x in appPrefs.myRivers) {
							var thislistname = stringLower (stringNthField (appPrefs.myRivers [x], "=", 2));
							console.log (thislistname);
							if (listname == thislistname) {
								if (stringLower (x) == stringLower (appPrefs.currentPanelName)) {
									console.log ("webSocketClient, updating the river: url == " + appPrefs.myRivers [x]);
									httpGetRiver (appPrefs.myRivers [x]);
									}
								break;
								}
							}
						break;
					case "readfeed":
						var urlfeed = trimWhitespace (words [1]);
						break;
					case "item":
						var jsontext = stringDelete (eventData, 1, 5); //pop off "item "
						break;
					default:
						console.log (words [0] + words [1]);
						break;
					}
				}
			
			};
		mySocket.onclose = function (evt) {
			console.log ("mySocket was closed.");
			mySocket = undefined;
			};
		mySocket.onerror = function (evt) {
			console.log ("mySocket received an error");
			};
		}

function panelExists (panelname) {
	panelname = panelname.toLowerCase ();
	for (var tabname in appPrefs.myRivers) { 
		if (tabname.toLowerCase () == panelname) {
			return (true);
			}
		}
	return (false);
	}
function getFirstPanelName () {
	for (var x in appPrefs.myRivers) { 
		return (x);
		}
	}
function buildTabs () { 
	$("#idTabList").empty ();
	for (var tabname in appPrefs.myRivers) { 
		var activetab = "", lowername = tabname.toLowerCase ();
		
		if (lowername == appPrefs.currentPanelName) {
			activetab = " class=\"active\""
			}
		
		var clickScript = "switchPanel (\"" + lowername + "\")";
		$("#idTabList").append ("<li" + activetab + " id='" + tabname + "'><a data-toggle=\"tab\" onclick='" + clickScript + "'>"  + tabname + "</a></li>");
		}
	}
function switchPanel (panelname) {
	var jsonFeed;
	console.log ("switchPanel: panelname == " + panelname);
	if (panelname == "null") {
		if (appPrefs.currentPanelName.length > 0) {
			panelname = appPrefs.currentPanelName;
			}
		else {
			panelname = getFirstPanelName ();
			}
		}
	panelname = panelname.toLowerCase ();
	for (var tabname in appPrefs.myRivers) { 
		if (tabname.toLowerCase () == panelname) {
			appPrefs.currentPanelName = panelname;
			jsonFeed = appPrefs.myRivers [tabname];
			break;
			}
		}
	if (jsonFeed === undefined) { //defensive driving -- use the first panel -- 2/5/16 by DW
		for (var x in appPrefs.myRivers) {
			jsonFeed = appPrefs.myRivers [x];
			appPrefs.currentPanelName = x.toLowerCase ();
			break;
			}
		}
	buildTabs ();
	console.log ("switchPanel: jsonFeed == " + jsonFeed);
	httpGetRiver (jsonFeed);
	whenLastTabSwitch = new Date ();
	}
function capitalizeFirstLetter (s) {
	return (s.charAt (0).toUpperCase () + s.slice (1));
	}
function everySecond () {
	if (mySocket === undefined) { //try to open the connection
		webSocketClient ("hello world");
		}
	}
function startup () {
	function setupPanels (callback) {
		console.log ("setupPanels: serverConfig == " + jsonStringify (serverConfig));
		if ((serverConfig.homePage !== undefined) && (serverConfig.homePage.panels !== undefined)) { 
			appPrefs.myRivers = new Object ();
			console.log ("setupPanels: getting panel names from serverConfig.homePage.");
			for (var i = 0; i < serverConfig.homePage.panels.length; i++) {
				var item = serverConfig.homePage.panels [i];
				var urlRiver = "getoneriver?fname=" + item.river;
				appPrefs.myRivers [item.title] = urlRiver;
				console.log ("setupPanels: " + item.title + " == " + urlRiver);
				}
			if (callback !== undefined) {
				callback ();
				}
			}
		else {
			readHttpFile ("getlistnames", function (jsontext) { //fallback to getting panel list from server
				if (jsontext !== undefined) {
					var listnames = JSON.parse (jsontext);
					appPrefs.myRivers = new Object ();
					for (var i = 0; i < listnames.length; i++) {
						var tabLabel = stringPopExtension (listnames [i]);  //turn iowa.opml to iowa
						var urlRiver = "getoneriver?fname=" + tabLabel + ".js";
						appPrefs.myRivers [capitalizeFirstLetter (tabLabel)] = urlRiver;
						}
					if (callback !== undefined) {
						callback ();
						}
					}
				});
			}
		}
	console.log ("startup");
	$("#idVersionNumber").html ("v" + appConsts.version);
	twStorageData.urlTwitterServer = appConsts.urlTwitterServer; //4/13/15 by DW
	initMenus ();
	hitCounter (); //9/4/14 by DW
	setupPanels (function () {
		console.log ("startup: appPrefs == " + jsonStringify (appPrefs));
		switchPanel (getURLParameter ("panel"));
		self.setInterval (everySecond, 1000); 
		});
	}
